package com.atlassian.jira.plugin.ext.bazaar;

import java.util.Collection;

import org.vcs.bazaar.client.BazaarRevision;
import org.vcs.bazaar.client.IBazaarLogMessage;

import com.atlassian.jira.plugin.ext.bazaar.linkrenderer.BazaarLinkRenderer;
import com.opensymphony.module.propertyset.PropertySet;

/**
 * 
 * @author Guillermo Gonzalez <guillo.gonzo@gmail.com>
 *
 */
public interface BazaarManager {
	Collection<IBazaarLogMessage> getLogEntries(BazaarRevision revision);

	IBazaarLogMessage getLogEntry(BazaarRevision revision);

	long getId();

	String getDisplayName();

	String getRoot();

	String getUsername();

	String getPassword();

	String getXmlRpcPort();

	String getBzrExecutable();

	boolean isActive();

	String getInactiveMessage();

	void activate();

	boolean isRevisionIndexing();

	int getRevisioningCacheSize();

	String getPrivateKeyFile();

	ViewLinkFormat getViewLinkFormat();

	BazaarLinkRenderer getLinkRenderer();

	void update(BzrProperties properties);

	PropertySet getProperties();
}