package com.atlassian.jira.plugin.ext.bazaar;

/**
 * @author Guillermo Gonzalez <guillo.gonzo@gmail.com>
 */
public class BazaarProperties implements BzrProperties {
	private String root;
	private String displayName;
	private Boolean revisionIndexing;
	private Integer revisioningCacheSize;
	private String changeSetFormat;
	private String webLinkType;
	private String viewFormat;
	private String fileAddedFormat;
	private String fileDeletedFormat;
	private String fileModifiedFormat;
	private String fileReplacedFormat;
	private String xmlRpcPort;
	private String bzrExecutable;

	public void fillPropertiesFromOther(BazaarProperties other) {
		if (this.getBzrExecutable() == null) {
			this.bzrExecutable = other.getBzrExecutable();
		}
		if (this.getXmlRpcPort() == null) {
			this.xmlRpcPort = other.getXmlRpcPort();
		}		
		if (this.getRevisionIndexing() == null) {
			this.revisionIndexing = other.getRevisionIndexing();
		}
		if (this.getRevisionCacheSize() == null) {
			this.revisioningCacheSize = other.getRevisionCacheSize();
		}

		if (webLinkType == null)
			setWebLinkType(other.getWebLinkType());

		if (changeSetFormat == null)
			setChangeSetFormat(other.getChangesetFormat());

		if (viewFormat == null)
			setViewFormat(other.getViewFormat());

		if (fileAddedFormat == null)
			setFileAddedFormat(other.getFileAddedFormat());

		if (fileDeletedFormat == null)
			setFileDeletedFormat(other.getFileDeletedFormat());

		if (fileModifiedFormat == null)
			setFileModifiedFormat(other.getFileModifiedFormat());

		if (fileReplacedFormat == null)
			setFileReplacedFormat(other.getFileReplacedFormat());
	}

	public String getWebLinkType() {
		return webLinkType;
	}

	public void setWebLinkType(String webLinkType) {
		this.webLinkType = webLinkType;
	}

	public String toString() {
		return "executable: " + getBzrExecutable() + " xmlrpc-port: " + getXmlRpcPort()
				+ " revisioningIndex: " + getRevisionIndexing()
				+ " revisioningCacheSize: " + getRevisionCacheSize();
	}

	public String getRoot() {
		return root;
	}

	public String getDisplayName() {
		return displayName;
	}

	public Boolean getRevisionIndexing() {
		return revisionIndexing;
	}

	public Integer getRevisionCacheSize() {
		return revisioningCacheSize;
	}

	public String getChangesetFormat() {
		return changeSetFormat;
	}

	public String getViewFormat() {
		return viewFormat;
	}

	public String getFileAddedFormat() {
		return fileAddedFormat;
	}

	public String getFileDeletedFormat() {
		return fileDeletedFormat;
	}

	public String getFileModifiedFormat() {
		return fileModifiedFormat;
	}

	public String getFileReplacedFormat() {
		return fileReplacedFormat;
	}

	public String getBzrExecutable() {
		return bzrExecutable;
	}

	public String getXmlRpcPort() {
		return xmlRpcPort;
	}

	public BazaarProperties setRoot(String root) {
		this.root = root;
		return this;
	}

	public BazaarProperties setDisplayName(String displayName) {
		this.displayName = displayName;
		return this;
	}

	public BazaarProperties setRevisionIndexing(Boolean revisionIndexing) {
		this.revisionIndexing = revisionIndexing;
		return this;
	}

	public BazaarProperties setRevisioningCacheSize(Integer revisioningCacheSize) {
		this.revisioningCacheSize = revisioningCacheSize;
		return this;
	}

	public BazaarProperties setChangeSetFormat(String changeSetFormat) {
		this.changeSetFormat = changeSetFormat;
		return this;
	}

	public BazaarProperties setViewFormat(String viewFormat) {
		this.viewFormat = viewFormat;
		return this;
	}

	public BazaarProperties setFileAddedFormat(String fileAddedFormat) {
		this.fileAddedFormat = fileAddedFormat;
		return this;
	}

	public BazaarProperties setFileDeletedFormat(String fileDeletedFormat) {
		this.fileDeletedFormat = fileDeletedFormat;
		return this;
	}

	public BazaarProperties setFileModifiedFormat(String fileModifiedFormat) {
		this.fileModifiedFormat = fileModifiedFormat;
		return this;
	}

	public BazaarProperties setFileReplacedFormat(String fileReplacedFormat) {
		this.fileReplacedFormat = fileReplacedFormat;
		return this;
	}

	public BazaarProperties setBzrExecutable(String bzrExecutable) {
		this.bzrExecutable = bzrExecutable;
		return this;
	}

	public BazaarProperties setXmlRpcPort(String xmlRpcPort) {
		this.xmlRpcPort = xmlRpcPort;
		return this;
	}

}
