package com.atlassian.jira.plugin.ext.bazaar.action;

import com.atlassian.jira.plugin.ext.bazaar.BazaarManager;
import com.atlassian.jira.plugin.ext.bazaar.MultipleBazaarRepositoryManager;

public class ActivateBazaarRepositoryAction extends BazaarActionSupport {

	private static final long serialVersionUID = 5520155242091523981L;

	private long repoId;
	private BazaarManager bazaarManager;

	public ActivateBazaarRepositoryAction(
			MultipleBazaarRepositoryManager manager) {
		super(manager);
	}

	public String getRepoId() {
		return Long.toString(repoId);
	}

	public void setRepoId(String repoId) {
		this.repoId = Long.parseLong(repoId);
	}

	public String doExecute() {
		if (!hasPermissions()) {
			return PERMISSION_VIOLATION_RESULT;
		}

		bazaarManager = getMultipleRepoManager().getRepository(repoId);
		bazaarManager.activate();
		if (!bazaarManager.isActive()) {
			addErrorMessage(getText("bazaar.repository.activation.failed",
					bazaarManager.getInactiveMessage()));
		}
		return SUCCESS;
	}

	public BazaarManager getBazaarManager() {
		return bazaarManager;
	}

}
