package com.atlassian.jira.plugin.ext.bazaar.action;

import com.atlassian.jira.plugin.ext.bazaar.BazaarManager;
import com.atlassian.jira.plugin.ext.bazaar.MultipleBazaarRepositoryManager;

public class DeleteBazaarRepositoryAction extends BazaarActionSupport {

	private static final long serialVersionUID = 950279167929159912L;

	private long repoId;
	private BazaarManager bazaarManager;

	public DeleteBazaarRepositoryAction(MultipleBazaarRepositoryManager manager) {
		super(manager);
	}

	public String getRepoId() {
		return Long.toString(repoId);
	}

	public void setRepoId(String repoId) {
		this.repoId = Long.parseLong(repoId);
	}

	public String doDefault() {
		if (!hasPermissions()) {
			return PERMISSION_VIOLATION_RESULT;
		}

		bazaarManager = getMultipleRepoManager().getRepository(repoId);
		return INPUT;
	}

	public String doExecute() {
		if (!hasPermissions()) {
			return PERMISSION_VIOLATION_RESULT;
		}

		getMultipleRepoManager().removeRepository(repoId);
		return getRedirect("ViewBazaarRepositories.jspa");
	}

	public BazaarManager getBazaarManager() {
		return bazaarManager;
	}
}
