package com.atlassian.jira.plugin.ext.bazaar.linkrenderer;

import org.vcs.bazaar.client.BazaarStatus;
import org.vcs.bazaar.client.IBazaarLogMessage;


/**
 * Used when the user does not specify any web links for Perforce - just return
 * String values, no links.
 */
public class NullLinkRenderer implements BazaarLinkRenderer {
	public String getRevisionLink(IBazaarLogMessage revision) {
		return revision.getRevision().getValue();
	}

	public String getChangePathLink(IBazaarLogMessage revision,
			BazaarStatus logEntryPath) {
		return logEntryPath.getPath();
	}

	public String getCopySrcLink(IBazaarLogMessage revision,
			BazaarStatus logEntryPath) {
		return logEntryPath.getPreviousPath() + " #"
				+ revision.getRevision().getValue();
	}
}