package com.atlassian.jira.plugin.ext.bazaar.projecttabpanels;

import java.util.Map;

import org.ofbiz.core.util.UtilMisc;
import org.vcs.bazaar.client.IBazaarLogMessage;

import com.atlassian.jira.plugin.ext.bazaar.MultipleBazaarRepositoryManager;
import com.atlassian.jira.plugin.ext.bazaar.issuetabpanels.changes.BazaarRevisionAction;
import com.atlassian.jira.plugin.projectpanel.ProjectTabPanelModuleDescriptor;
import com.atlassian.jira.web.action.JiraWebActionSupport;

/**
 * One item in the 'Bazaar Commits' project tab.
 * 
 * This class extends {@link BazaarRevisionAction} (basically, there is no issue
 * to group by here, and we need to use a ProjectTabPanelModuleDescriptor in
 * stead of an IssueTabPanelModuleDescriptor)
 */
public class BazaarProjectRevisionAction extends BazaarRevisionAction {
	protected final ProjectTabPanelModuleDescriptor projectDescriptor;

	public BazaarProjectRevisionAction(IBazaarLogMessage logEntry,
			MultipleBazaarRepositoryManager multipleBazaarRepositoryManager,
			ProjectTabPanelModuleDescriptor descriptor, long repoId) {
		super(logEntry, multipleBazaarRepositoryManager, null, repoId);
		this.projectDescriptor = descriptor;
	}

	@SuppressWarnings("unchecked")
	public String getHtml(JiraWebActionSupport webAction) {
		Map params = UtilMisc.toMap("webAction", webAction, "action", this);
		return descriptor.getHtml("view", params);
	}
}
