package com.atlassian.jira.plugin.ext.bazaar;

import java.util.HashMap;

import junit.framework.TestCase;

import com.opensymphony.module.propertyset.map.MapPropertySet;

public class TestBzrProperties extends TestCase
{
    public void testNullDisplayName()
    {


        MapPropertySet propertySet = new MapPropertySet();
        propertySet.setMap(new HashMap());

        BazaarProperties properties = new BazaarProperties()
                                                .setRoot("/root/repo")
                                                .setRevisionIndexing(Boolean.TRUE)
                                                .setRevisioningCacheSize(new Integer(1000))
                                                .setBzrExecutable("/usr/bin/bzr")
                                                .setXmlRpcPort("11113");

        BzrProperties.Util.fillPropertySet(properties, propertySet);

        assertEquals("/root/repo", propertySet.getString(MultipleBazaarRepositoryManager.BZR_BRANCH_ROOT_KEY));
        assertEquals("/root/repo", propertySet.getString(MultipleBazaarRepositoryManager.BZR_REPOSITORY_NAME));
        assertEquals("/usr/bin/bzr", propertySet.getString(MultipleBazaarRepositoryManager.BZR_EXECUTABLE));
        assertEquals("11113", propertySet.getString(MultipleBazaarRepositoryManager.BZR_XMLRPC_PORT));
    }
}
