package com.atlassian.jira.plugin.ext.bazaar.revisions;

import java.io.File;
import java.io.InputStream;
import java.net.URI;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.vcs.bazaar.client.BazaarClient;
import org.vcs.bazaar.client.BazaarNotificationHandler;
import org.vcs.bazaar.client.BazaarRevision;
import org.vcs.bazaar.client.BazaarTreeStatus;
import org.vcs.bazaar.client.BazaarVersionInfo;
import org.vcs.bazaar.client.IBazaarAnnotation;
import org.vcs.bazaar.client.IBazaarInfo;
import org.vcs.bazaar.client.IPlugin;
import org.vcs.bazaar.client.IBazaarItemInfo;
import org.vcs.bazaar.client.IBazaarLogMessage;
import org.vcs.bazaar.client.IBazaarNotifyListener;
import org.vcs.bazaar.client.IBazaarPromptUserPassword;
import org.vcs.bazaar.client.IBazaarRevisionSpec;
import org.vcs.bazaar.client.IBzrLogMessageHandler;
import org.vcs.bazaar.client.commandline.commands.options.Option;
import org.vcs.bazaar.client.commandline.internal.CommandRunner;
import org.vcs.bazaar.client.core.BazaarClientException;
import org.vcs.bazaar.client.core.BranchLocation;

/**
 * An BZRRepository implementation for testing exception handling in our code which calls BZRRepository methods
 * which can all throw exceptions.
 */
class MockBzrRepository extends BazaarClient
{
    private final boolean explode;
    private boolean runtimeException;
    private boolean methodsWereCalled;

    /**
     * Creates a BZRRepository implementation that will optionally throw an BZRException or RuntimeException
     * for almost all methods.
     *
     * @param explode          set to true if an exception should be thrown.
     * @param runtimeException set to true if the exception should be a RuntimeException, false means BZRException.
     */
    public MockBzrRepository(boolean explode, boolean runtimeException) {
        super();
        this.explode = explode;
        this.runtimeException = runtimeException;
        this.methodsWereCalled = false;
    }

   
    @Override
	protected CommandRunner getCommandRunner() {
		// TODO Auto-generated method stub
		return null;
	}

	public void addNotifyListener(IBazaarNotifyListener listener) {
		// TODO Auto-generated method stub
		
	}

	public void addPasswordCallback(IBazaarPromptUserPassword callback) {
		// TODO Auto-generated method stub
		
	}
	
	public BazaarNotificationHandler getNotificationHandler() {
		// TODO Auto-generated method stub
		return null;
	}
	
	public void removeNotifyListener(IBazaarNotifyListener listener) {
		// TODO Auto-generated method stub		
	}

	public void add(File[] files, Option... options) throws BazaarClientException {
		maybeExplode();
	}
	
	public IBazaarAnnotation annotate(File file, Option... options)
			throws BazaarClientException {
		maybeExplode();
		return null;
	}

	public void bind(BranchLocation location, Option... options)
			throws BazaarClientException {
		maybeExplode();
	}

	public void branch(BranchLocation fromLocation, File toLocation,
			IBazaarRevisionSpec revision, Option... options)
			throws BazaarClientException {
		maybeExplode();
	}

	public InputStream cat(File file, IBazaarRevisionSpec revision,
			Option... options) throws BazaarClientException {
		maybeExplode();
		return null;
	}

	public InputStream cat(File file, IBazaarRevisionSpec revision,
			String charsetName, Option... options) throws BazaarClientException {
		maybeExplode();
		return null;
	}

	public void checkout(BranchLocation fromLocation, File toLocation,
			Option... options) throws BazaarClientException {
		maybeExplode();
	}

	public void commit(File[] files, String message, Option... options)
			throws BazaarClientException {
		maybeExplode();
	}

	public String diff(File file, IBazaarRevisionSpec range, Option... options)
			throws BazaarClientException {
		maybeExplode();
		return null;
	}

	public BazaarRevision findMergeBase(BranchLocation branch,
			BranchLocation other) throws BazaarClientException {
		maybeExplode();
		return null;
	}

	public void ignore(File file, String pattern) throws BazaarClientException {
		maybeExplode();		
	}

	public Map<String, String> ignored(File file) throws BazaarClientException {
		maybeExplode();
		return null;
	}

	public IBazaarInfo info(File location, Option... options)
			throws BazaarClientException {
		maybeExplode();
		return null;
	}
	
	public IBazaarInfo info(BranchLocation location, Option... options)
			throws BazaarClientException {
		maybeExplode();
		return null;
	}
	
	//ah, y tengo otro link para faciliar un poco el armado de prototipos, de vista al usuario. me gustó bastante 

	public void init(File location, Option... options)
			throws BazaarClientException {
		maybeExplode();
	}

	public List<IBazaarLogMessage> log(BranchLocation location, Option... options)
			throws BazaarClientException {
		maybeExplode();
		return null;
	}

	public List<IBazaarLogMessage> log(File location, Option... options)
			throws BazaarClientException {
		maybeExplode();
		return null;
	}

	public List<IBazaarLogMessage> log(URI location, Option... options)
			throws BazaarClientException {
		maybeExplode();
		return null;
	}
	
	public void log(BranchLocation location, IBzrLogMessageHandler logHandler,
			Option... options) throws BazaarClientException {
		maybeExplode();
	}


	public void logAsync(BranchLocation location,
			IBzrLogMessageHandler logHandler, Option... options)
			throws BazaarClientException {
		maybeExplode();
	}

	public IBazaarItemInfo[] ls(File workDir, IBazaarRevisionSpec revision,
			Option... options) throws BazaarClientException {
		maybeExplode();
		return null;
	}

	public void merge(BranchLocation otherBranch, Option... options)
			throws BazaarClientException {
		maybeExplode();		
	}

	public Map<String, List<IBazaarLogMessage>> missing(File workdir,
			BranchLocation otherBranch, Option... options)
			throws BazaarClientException {
		maybeExplode();
		return null;
	}

	public Map<String, List<IBazaarLogMessage>> missing(File workdir,
			URI otherBranch, Option... options) throws BazaarClientException {
		maybeExplode();
		return null;
	}

	public void move(File orig, File dest, Option... options)
			throws BazaarClientException {
		maybeExplode();
	}

	public void move(File[] orig, File dest, Option... options)
			throws BazaarClientException {
		maybeExplode();
	}

	public String nick(String newNick) throws BazaarClientException {
		maybeExplode();
		return null;
	}

	public Set<IPlugin> plugins() throws BazaarClientException {
		maybeExplode();
		return null;
	}

	public void pull(BranchLocation location, Option... options)
			throws BazaarClientException {
		maybeExplode();		
	}

	public void pull(URI location, Option... options)
			throws BazaarClientException {
		maybeExplode();		
	}

	public void push(BranchLocation location, Option... options)
			throws BazaarClientException {
		maybeExplode();		
	}

	public void push(URI location, Option... options)
			throws BazaarClientException {
		maybeExplode();
	}

	public void remove(File[] files, Option... options)
			throws BazaarClientException {
		maybeExplode();
	}

	public void resolve(List<File> files, Option... options)
			throws BazaarClientException {
		maybeExplode();
	}

	public void revert(File[] files, Option... options)
			throws BazaarClientException {
		maybeExplode();
	}

	public BazaarRevision revisionInfo(File location, BazaarRevision revision)
			throws BazaarClientException {
		maybeExplode();
		return BazaarRevision.INVALID;
	}
	
	public BazaarRevision revisionInfo(File location,
			IBazaarRevisionSpec revision) throws BazaarClientException {
		maybeExplode();
		return BazaarRevision.INVALID;
	}

	public BazaarRevision revno(File location) throws BazaarClientException {
		maybeExplode();
		return BazaarRevision.INVALID;
	}
	
	public BazaarRevision revno(BranchLocation location) throws BazaarClientException {
		maybeExplode();
		return BazaarRevision.INVALID;
	}

	public void send(BranchLocation submitBranch, Option... options)
			throws BazaarClientException {
		maybeExplode();		
	}

	public BazaarTreeStatus status(File[] files, Option... options)
			throws BazaarClientException {
		maybeExplode();
		return new BazaarTreeStatus();
	}

	public void switchBranch(BranchLocation location, Option... options)
			throws BazaarClientException {
		maybeExplode();
	}

	public void unBind(Option... options) throws BazaarClientException {
		maybeExplode();
	}

	public void unCommit(File location, Option... options)
			throws BazaarClientException {
		maybeExplode();
	}

	public String[] unknowns(File workDir) throws BazaarClientException {
		maybeExplode();
		return new String[0];
	}

	public String update(File file, Option... options)
			throws BazaarClientException {
		maybeExplode();
		return "1";
	}
	
	public BazaarVersionInfo versionInfo(BranchLocation location, Option... options)
			throws BazaarClientException {
		maybeExplode();
		return null;
	}

    public boolean methodsWereCalled()
    {
        return methodsWereCalled;
    }

    private void maybeExplode() throws BazaarClientException
    {
        methodsWereCalled = true;
        if (explode)
        {
            if (runtimeException)
            {
                throw new RuntimeException("As requested.");
            }
            else
            {
                throw new BazaarClientException("none");
            }
        }
    }

    private int returnNumber() throws BazaarClientException
    {
        maybeExplode();
        return 123;

    }

}
